// Called when we click the right menu option to add the torrent
function abcadd() {
    if (gContextMenu) {
        // Get the preferences
        var server = null;
        var port = null;
        var id = "";
        var prefservice = Components.classes
            ["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
        var prefs = prefservice.getBranch("");
        if (prefs.getPrefType("abcadd.server") == prefs.PREF_STRING) {
            server = prefs.getCharPref("abcadd.server");
        }
        if (prefs.getPrefType("abcadd.port") == prefs.PREF_INT) {
            port = prefs.getIntPref("abcadd.port");
        }
        if (prefs.getPrefType("abcadd.id") == prefs.PREF_STRING) {
            id = prefs.getCharPref("abcadd.id");
        }
        
        if (server != null && port != null && server != "") {
            // Form the command
            var command = "ID|" + id + "\nADD|" + gContextMenu.linkURL();
        
            // Create a link to the service
            try {
                // Prepare the out and in bound streams
                var transportService =
                    Components.classes
                    ["@mozilla.org/network/socket-transport-service;1"]
                    .getService
                    (Components.interfaces.nsISocketTransportService);
                var transport = transportService.createTransport(null,
                                                                 0,
                                                                 server,
                                                                 port,
                                                                 null);
                var outstream = transport.openOutputStream(0, 0, 0);
                var stream = transport.openInputStream(0,0,0);
                var instream = Components.classes
                    ["@mozilla.org/scriptableinputstream;1"]
                    .createInstance
                    (Components.interfaces.nsIScriptableInputStream);
                instream.init(stream);

                // The listener object
                var dataListener = {
                    data : "",
                    onStartRequest: function(request, context) {},
                    onStopRequest: function(request, context, status) {
                        instream.close();
                        outstream.close();

                        if (this.data == "") {
                            alert("ABCAdd failed: No response, check options");
                        }
                        
                        var errorStart =
                          this.data.toLowerCase().indexOf("error");
                        if (errorStart != -1) {
                            alert("ABCAdd failed: " +
                                  this.data.substr(errorStart));
                        }
                    },
                    onDataAvailable: function(request, context,
                                              inputStream, offset, count) {
                        this.data += instream.read(count);
                    },
                };

                // Set up callback for input
                var pump = Components.
                    classes["@mozilla.org/network/input-stream-pump;1"].
                    createInstance(Components.interfaces.nsIInputStreamPump);
                pump.init(stream, -1, -1, 0, 0, false);
                pump.asyncRead(dataListener, null);
                
                // Send the command
                outstream.write(command, command.length);
            } catch(e) {
                alert("ABCAdd failed: " + e);
            }
        } else {
            alert("ABCAdd: Please set the server and port\n" +
                  "in extension options before use");
        }
    }
}

// Called when the preference dialog is opened
function getPrefs() 
{
    var prefservice = Components.classes
        ["@mozilla.org/preferences-service;1"].
        getService(Components.interfaces.nsIPrefService);
    var prefs = prefservice.getBranch("");
    if (prefs.getPrefType("abcadd.server") == prefs.PREF_STRING) {
        var value = prefs.getCharPref("abcadd.server");
        document.getElementById('abcserver').value = value;
    }
    if (prefs.getPrefType("abcadd.port") == prefs.PREF_INT) {
        var value = prefs.getIntPref("abcadd.port");
        document.getElementById('abcport').value = value;
    }
    if (prefs.getPrefType("abcadd.id") == prefs.PREF_STRING) {
        var value = prefs.getCharPref("abcadd.id");
        document.getElementById('abcid').value = value;
    }
}

// Called when the preference dialog is closed
function setPrefs() {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefService);
    var prefs = prefService.getBranch("");
    prefs.setCharPref("abcadd.server",
                      document.getElementById('abcserver').value);
    prefs.setIntPref("abcadd.port",
                     document.getElementById('abcport').value);
    prefs.setCharPref("abcadd.id",
                      document.getElementById('abcid').value);
    window.close();
}

// Called when the right click context menu is created
function abcaddPopup(aEvent) {
    if (gContextMenu) {
        var menuitem = document.getElementById("abcaddlink");
        var sepitem = document.getElementById("abcaddsep");
        if (menuitem && sepitem) {
            // If the menu isn't a link menu diable the item
            menuitem.hidden = (!gContextMenu.onLink);
            sepitem.hidden = (!gContextMenu.onLink);
               
            // If the link is javascript disable it
            if (gContextMenu.linkURL().substr(0, 11).toLowerCase()
                == "javascript:") {
                menuitem.setAttribute('disabled', 'true');
            }
         }
      }
}

// Called when loaded
function abcaddInit(aEvent) {
    var menu = document.getElementById("contentAreaContextMenu");

    if (menu) {
        menu.addEventListener("popupshowing", abcaddPopup, false);
    }
}

// Add the load listener
window.addEventListener("load", abcaddInit, false);
